supposed functions and variables:
	int[,] SobelData = new int[picWIDTH, picHEIGHT];
	int[,] BWArray = new int[picWIDTH, picHEIGHT];
	int[,] xmask = new int[3,3] //horizontal sobel mask
	int[,] ymask = new int[3,3] //vertical sobel mask
	int picWIDTH = //TO BE SET
	int picHEIGHT = //TO BE SET
	int[,] history = new int[3,2]; //history(0,0)= top last hcenter history(0,1)=top last wcenter
                                  //history(1,0)=middle last hcenter history(1,1)=middle last wcenter
                                  //history(2,0)=bottom last hcenter history(2,1)=bottom last wcenter
	
	int bfln = 3;	//Private Const bfln = 3 'best-fit-line-n -->best fit line value of n (number of points)
					//MAKE CONST (ml)

//*************************sobel() subroutine*************************
//
//  purpose: take an image and weight the pixels to find the differences
//           and then save the differences (edges) only
//
//   input: black and white video data in the BWArray array
//          xmask and ymask arrays holding the weights to be given to adjacent pixels
//
//   output: sobel data that is stored in the SobelData array  which is
//           then used in the translate subroutine
//
//********************************************************************

Sub sobel()	int //STILL NEEDS TO BE CHANGE TO C# FUNCTION (ml)
    int x1; //row of picture
    int y1; //col of picture
    
    int sumx; //sum based on xmask weights
    int sumy; //sum based on ymask weights
    int sum; //overall absolute value of combined weights-->is the final sobel data
    
    int i;
	int j;
    
    for ( x1 = 0; x1 <= (picHEIGHT -1); x1++) //fill in rows 120 to 1 COULD BE < (ml)
	{
		for ( y1 = 0; y1 <= (picHEIGHT -1); y1++) //fill in rows 120 to 1	COULD BE < (ml)
		{
             sumx = 0; //reinitialize these to zero every time through the loop
             sumy = 0;
             SobelData[y1][x1] = 255; //initialize each element of the array (avoids separate initializing loop)
             
             //if not on the border of the image, step into the if statement
			 if ( y1 != 0 && y1 != (picWIDTH - 1) && x1 != 0 && x1 != picHEIGHT - 1)
             {
                 for (i = -1; i <= 1; i++)    //work through the masks (MILES NOTE: MAYBE <1 (?) )
				 {
                     for (j = -1; j <= 1; j++)  //move across columns first, then go to next row
					 {
                         //pic is stored (col, row) while the mask is (row,col)
                         //x and i refer to rows, y and j refer to columns
                         sumx = sumx + BWArray[y1 + j][x1 + i] * xmask[i + 2][j + 2]
                         sumy = sumy + BWArray[y1 + j][x1 + i] * ymask[i + 2][j + 2]
                     }
                 }
                 
                 sum = Math.Abs(sumx) + Math.Abs(sumy); //the larger the overall absolute value, the greater the difference
                                             //between the adjacent pixels
                     
                 //adjust the meaning of "black" and "white" via the slider control on the form
                 /*If sum >= (255 - sliderval) Then
                     sum = 255
                 ElseIf sum <= sliderval Then
                     sum = 0
                 Else
                     sum = 0
                 End If*/
        
                 SobelData[y1][x1] = 255 - sum; //subtract so edges are outlined in black, everything else is white
             }
        }
    }
    
    //Call translate	(unnecessary if translate is only creating .bmp (ml) )
	
	
/*	'*************************translate() subroutine*********************
'
'   purpose: takes the data computed by sobel and reverses it so it
'            is in .bmp format and then displays the result in a
'            picturebox control
'
'   input: SobelData array
'
'   output: datab2 array
'           image on the screen
'
'********************************************************************
Sub translate()
  Dim p As Long
  Dim i As Integer
  Dim j As Integer
  
  p = 57599
  For j = 0 To picHEIGHT - 1
    For i = picWIDTH - 1 To 0 Step -1
        datab2(p - 2) = SobelData(i, j)
        datab2(p - 1) = SobelData(i, j)
        datab2(p) = SobelData(i, j)
        p = p - 3
    Next i
  Next j

    Call RtlMoveMemory(VarPtr(datab1(54)), VarPtr(datab2(0)), 57600)
    Call DisplayImage(Picture4.hwnd)
End Sub*/


/***********************center finding functions**********************
'
'   these get called to find the center of an object
'       draws the line segments and the best-fit line
'
'   -findcenter--calls: "centers" fuction
'                       "bestfitline" function
'                       "linesegments" function
'               -then displays the "forecast"
'
'********************************************************************/

/*'*************************findcenter() subroutine********************
'
'   purpose: takes the data computed by sobel and the history array
'            to find the center of an object
'
'   input: SobelData array
'          history array
'
'   output: updated history array
'           bestfine called to display best fit line
'           linesegments called to draw the line segments between the
'               history points
'
'*********************************************************************/
Sub findcenter()	int	//STILL TO BE DECLARED C# FUNCTION (ml)
{
    int howmany;
    for ( howmany = 0; howmany <= bfln - 1; howmany++ )
        centers(history[howmany, 0)], history[howmany, 1], howmany); //RETURNS/REFERENCE OR COPY?? (ml)
    
    linesegments();	//RETURNS??? (ml)
    bestfitline();	//RETURNS??? (ml)
    
    if ( bfln > 1 )
	{
        int mvmntforecast;
        mvmntforecast = history[0, 1] - history[1, 1] //top minus middle
        //middiff.Caption = mvmntforecast 	IS THIS AN OBJECT ON FORM??? (ml)
        //****this line is actually the visual representation of the forecast
        //Picture4.ScaleMode = vbPixels
        //Picture4.DrawWidth = 5
        //Picture4.Line (history(1, 1), history(1, 0))-(history(1, 1) + mvmntforecast, history(1, 0) - 20), RGB(255, 255, 0)
    }
}


/*'*************************centers() subroutine***********************
'
'   purpose: calls findedge for each point in the history array to find
'            the right and left edges and then computes the average midpoint
'
'   input: SobelData array
'          history array
'
'   output: updated history array
'
'********************************************************************/
Sub centers(int hcenter, int wcenter, int hisloc)
{
    int below; //how far below center to look
    int above; //how far above center to look
    int middle; //the middle of the object
    int right = 0; //sum of pixel locations for right edge
    int left = 0; //sum of pixel locations for left edge
    
    below = hcenter - 10;
    above = hcenter + 10;
    for (int i = below; i <= above; i++)
	{	
		right = right + findedge(wcenter, i, true);
        left = left + findedge(wcenter, i, false);
    }
    middle = ((right / (above - below)) - (left / (above - below))) / 2 + (left / (above - below))
    
    //prevents the points from getting "stuck" at the edge of the image
    if ( middle > (picWIDTH - 15))
		middle = picWIDTH - 15;
    if ( middle < 15 )
		middle = 15;
    history[hisloc, 1] = middle;	//IS THIS A GLOBAL VARIABLE??? (ml)
}

/**************************findedge() function************************
'
'   purpose: looks in sobeldata array in the direction designated
'            until it finds an edge (or the edge of the image)
'
'   input: SobelData array
'
'   output: returns integer value of pixel location designating the
'           the first edge found in the specified direction
'
'********************************************************************/
int findedge(int startw, int starth, bool goright)
{
    int direction;
    const bool found = true; //CHECK (ml)
    bool edge = false;
    int x = startw
	int y = starth;
    
    if (goright)
		direction = 1;
	else
		direction = -1;

    //use SobelData...it has what is being displayed
    int While (edge <> found) And x < picWIDTH And x >= 0	//??? (ml)
	{
        if (SobelData[x, y] == 0)
            edge = true;
        else
            x = x + direction;
    }
    return x;
}

/*************************bestfitline() subroutine*******************
'
'   purpose: takes the points in the history array and computes
'            the best fit line (the line that lies closest to all the points
'
'   input: history array
'
'   output: draws the best fit line in the picturebox control
'           displays beginning and end coordinates of the best fit line
'           displays the slope and y-intercept of the best fit line
'
'********************************************************************/
Sub bestfitline()
{
    int shiftx = 80; //how much to shift x and y to make screen MAY NOT BE MIDDLE (ml)
    int shifty = 120; //work better with cartesian coordinates CHECK COORDINATES (ml)
    //make origin start at middle of screen
    //and also shift it to the bottom of the screen
    
    int vertline = history[0,1]; //where to draw the line if the slope is undefined

    double sumx = 0; //sumx is summation of x
    double sumy = 0; //sumy is summation of y
    double sumxy = 0; //sumxy is summation of x*y
    double sumxsq = 0; //sumxsq is summation of x*x
    double a, b, temp1, temp2, x1, x2, y1, y2; //a and b derive from line formula-->y=a+bx
    //best fit line goes from (x1,y1) to (x2,y2)
    
    for (int i = 0; i <= (bfln - 1); i++)
	{
        sumx = sumx + (history[i, 1] - shiftx);
        sumy = sumy + (shifty - history[i, 0]);
        sumxy = sumxy + ((history[i, 1] - shiftx) * (shifty - history[i, 0]));
        sumxsq = sumxsq + ((history[i, 1] - shiftx) * (history[i, 1] - shiftx));
    }
    temp1 = (sumxsq * sumy) - (sumx * sumxy);
    temp2 = (bfln * sumxsq) - (sumx ^ 2);
    if (temp2 != 0)
        a = temp1 / temp2;
    temp1 = (bfln * sumxy) - (sumx * sumy);
    if (temp2 != 0)
        b = temp1 / temp2;
    //y=a+bx
    //x=(y-a)/b
    
    y1 = history[0,0];
    y2 = history[bfln - 1, 0]
    if (b == 0) //vertical line problem-->vertical slope means division by zero
        x1 = vertline;
        x2 = vertline;
    else
        //translate back into screen coordinates from shifted cartesian coordinates
        x1 = (((shifty - y1) - a) / b) + shiftx;
        x2 = (((shifty - y2) - a) / b) + shiftx;

    /*lx1.Caption = x1
    lx2.Caption = x2
    ly1.Caption = y1
    ly2.Caption = y2
    lb.Caption = a*
    If b = 0 Then
        lm.Caption = "infinity"
    Else
        lm.Caption = b
    End If
    Picture4.ScaleMode = vbPixels
    Picture4.DrawWidth = 5
    Picture4.Line (x1, y1)-(x2, y2), RGB(255, 0, 0)*/ //WHAT IS ALL THIS SHIT??? (ml)
}

/**************************linesegments() subroutine******************
'
'   purpose: takes the points in the history array and computes
'            draws the line segments between each pair of points
'
'   input: history array
'
'   output: draws the line segments in the picturebox control
'           draws a small circle at each of the points in the history array
'
'********************************************************************/
Sub linesegments()
{
    /*Picture4.ScaleMode = vbPixels
    Picture4.DrawWidth = 5*/ 	// ??? (ml)
    
    for (int i = 0; i <= bfln - 2; i++)
        Picture4.Line (history((i + 1), 1), history((i + 1), 0))-(history(i, 1), history(i, 0)), RGB(0, 255, 0);

    for (int i = 0; i <= bfln - 1; i++)
        Picture4.Circle (history(i, 1), history(i, 0)), 5, RGB(0, 0, 255);
}



'**********************historyinit() subroutine**********************
'
'   purpose: create an array of points that will be used for finding
'            the center of an object as defined by the edges found by
'            sobel()
'
'   input: none
'
'   output: x and y values for starting locations for the center points
'           of an object
'
'********************************************************************
Sub historyinit()
    history(0, 0) = 40 'y1
    history(0, 1) = 80 'x1
    history(1, 0) = 60 'y2
    history(1, 1) = 80 'x2
    history(2, 0) = 80 'y3
    history(2, 1) = 80 'x3
End Sub

'**********************initmask() subroutine*************************
'
'   purpose: initialize the masks used by sobel() giving adjacent
'            pixels the appropriate "weight"
'
'   input: none
'
'   output: two matrices defining the weights to be used on adjacent
'           pixels when finding the sobel data
'
'   note: increasing the values in the masks will increase the
'           sensitivity of sobel...however, for the most part this
'           simply means more "noise" rather than better defined edges
'   also: the numbers have to stay relatively small because of the
'           sobel computations-->the bigger the multiplier in the matrix
'           the higher the results are on average, meaning more pixels
'           are black more often (hence the noise issue)
'
'********************************************************************
Sub initmask()
    '   -1  0   1
    '   -2  0   2
    '   -1  0   1
    xmask(1, 1) = -1
    xmask(1, 2) = 0
    xmask(1, 3) = 1
    xmask(2, 1) = -2
    xmask(2, 2) = 0
    xmask(2, 3) = 2
    xmask(3, 1) = -1
    xmask(3, 2) = 0
    xmask(3, 3) = 1
    
    '    1   2   1
    '    0   0   0
    '   -1  -2  -1
    ymask(1, 1) = 1
    ymask(1, 2) = 2
    ymask(1, 3) = 1
    ymask(2, 1) = 0
    ymask(2, 2) = 0
    ymask(2, 3) = 0
    ymask(3, 1) = -1
    ymask(3, 2) = -2
    ymask(3, 3) = -1
End Sub